import { KeyValueCacheSetOptions, TestableKeyValueCache } from 'apollo-server-caching';
import { Connection } from 'mysql';
export interface SqlCacheOptions {
    client: Connection;
    databaseName: string;
    tableName?: string;
    deleteExpiredItems?: boolean;
}
export declare class SqlCache implements TestableKeyValueCache<string> {
    protected client: Connection;
    protected databaseName: string;
    protected tableName: string;
    protected deleteExpiredItems: boolean;
    protected readonly defaultSetOptions: KeyValueCacheSetOptions;
    constructor(options: SqlCacheOptions);
    /**
     * Retrieve an item from the cache.
     */
    get(key: string): Promise<string | undefined>;
    /**
     * Put a new item in the cache.
     */
    set(key: string, value: string, options?: KeyValueCacheSetOptions): Promise<void>;
    /**
     * Delete a cached item
     */
    delete(key: string): Promise<boolean>;
    /**
     * Convert a mysql query to a promise.
     */
    protected promisifyQuery<T>(query: string, data: any): Promise<T>;
}
